import 'EventData.dart';

/// just a placeholder class to ease internal type checks
/// user should extend it as per their need
///
class EventID {
  /// debug string only used if eventizer's log was enabled
  final String dstr;

  /// create event with debug string [dstr] passed
  const EventID({this.dstr = 'GEvent'});

  /// simply return debug string
  @override
  String toString() => dstr;

  /// facilator api to return an [Event] Object encapsulating this [EventID]
  /// with passed [data]
  Event toEvent([data]) {
    switch (data?.runtimeType ?? String) {
      case List:
        return EventMulti(this, data);
      case Map:
        return EventMap(this, data);
      default:
        return Event(this, data);
    }
  }
}
